# Copyright 2017 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This class is auto generated by the swagger code generator program.
# https://github.com/swagger-api/swagger-codegen.git
# Do not edit the class manually.

defmodule GoogleApi.Monitoring.V3.Model.CollectdValue do
  @moduledoc """
  A single data point from a collectd-based plugin.

  ## Attributes

  - dataSourceName (String.t): The data source for the collectd value. For example there are two data sources for network measurements: \&quot;rx\&quot; and \&quot;tx\&quot;. Defaults to: `null`.
  - dataSourceType (String.t): The type of measurement. Defaults to: `null`.
    - Enum - one of [UNSPECIFIED_DATA_SOURCE_TYPE, GAUGE, COUNTER, DERIVE, ABSOLUTE]
  - value (TypedValue): The measurement value. Defaults to: `null`.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :dataSourceName => any(),
          :dataSourceType => any(),
          :value => GoogleApi.Monitoring.V3.Model.TypedValue.t()
        }

  field(:dataSourceName)
  field(:dataSourceType)
  field(:value, as: GoogleApi.Monitoring.V3.Model.TypedValue)
end

defimpl Poison.Decoder, for: GoogleApi.Monitoring.V3.Model.CollectdValue do
  def decode(value, options) do
    GoogleApi.Monitoring.V3.Model.CollectdValue.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Monitoring.V3.Model.CollectdValue do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
