# Copyright 2017 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This class is auto generated by the swagger code generator program.
# https://github.com/swagger-api/swagger-codegen.git
# Do not edit the class manually.

defmodule GoogleApi.Monitoring.V3.Model.Exemplar do
  @moduledoc """
  Exemplars are example points that may be used to annotate aggregated distribution values. They are metadata that gives information about a particular value added to a Distribution bucket, such as a trace ID that was active when a value was added. They may contain further information, such as a example values and timestamps, origin, etc.

  ## Attributes

  - attachments ([Object]): Contextual information about the example value. Examples are:Trace: type.googleapis.com/google.monitoring.v3.SpanContextLiteral string: type.googleapis.com/google.protobuf.StringValueLabels dropped during aggregation:  type.googleapis.com/google.monitoring.v3.DroppedLabelsThere may be only a single attachment of any given message type in a single exemplar, and this is enforced by the system. Defaults to: `null`.
  - timestamp (DateTime.t): The observation (sampling) time of the above value. Defaults to: `null`.
  - value (float()): Value of the exemplar point. This value determines to which bucket the exemplar belongs. Defaults to: `null`.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :attachments => list(GoogleApi.Monitoring.V3.Model.Object.t()),
          :timestamp => DateTime.t(),
          :value => any()
        }

  field(:attachments, as: GoogleApi.Monitoring.V3.Model.Object, type: :list)
  field(:timestamp, as: DateTime)
  field(:value)
end

defimpl Poison.Decoder, for: GoogleApi.Monitoring.V3.Model.Exemplar do
  def decode(value, options) do
    GoogleApi.Monitoring.V3.Model.Exemplar.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Monitoring.V3.Model.Exemplar do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
