# Copyright 2017 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This class is auto generated by the swagger code generator program.
# https://github.com/swagger-api/swagger-codegen.git
# Do not edit the class manually.

defmodule GoogleApi.Monitoring.V3.Model.Field do
  @moduledoc """
  A single field of a message type.

  ## Attributes

  - cardinality (String.t): The field cardinality. Defaults to: `null`.
    - Enum - one of [CARDINALITY_UNKNOWN, CARDINALITY_OPTIONAL, CARDINALITY_REQUIRED, CARDINALITY_REPEATED]
  - defaultValue (String.t): The string value of the default value of this field. Proto2 syntax only. Defaults to: `null`.
  - jsonName (String.t): The field JSON name. Defaults to: `null`.
  - kind (String.t): The field type. Defaults to: `null`.
    - Enum - one of [TYPE_UNKNOWN, TYPE_DOUBLE, TYPE_FLOAT, TYPE_INT64, TYPE_UINT64, TYPE_INT32, TYPE_FIXED64, TYPE_FIXED32, TYPE_BOOL, TYPE_STRING, TYPE_GROUP, TYPE_MESSAGE, TYPE_BYTES, TYPE_UINT32, TYPE_ENUM, TYPE_SFIXED32, TYPE_SFIXED64, TYPE_SINT32, TYPE_SINT64]
  - name (String.t): The field name. Defaults to: `null`.
  - number (integer()): The field number. Defaults to: `null`.
  - oneofIndex (integer()): The index of the field type in Type.oneofs, for message or enumeration types. The first type has index 1; zero means the type is not in the list. Defaults to: `null`.
  - options ([Option]): The protocol buffer options. Defaults to: `null`.
  - packed (boolean()): Whether to use alternative packed wire representation. Defaults to: `null`.
  - typeUrl (String.t): The field type URL, without the scheme, for message or enumeration types. Example: \&quot;type.googleapis.com/google.protobuf.Timestamp\&quot;. Defaults to: `null`.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :cardinality => any(),
          :defaultValue => any(),
          :jsonName => any(),
          :kind => any(),
          :name => any(),
          :number => any(),
          :oneofIndex => any(),
          :options => list(GoogleApi.Monitoring.V3.Model.Option.t()),
          :packed => any(),
          :typeUrl => any()
        }

  field(:cardinality)
  field(:defaultValue)
  field(:jsonName)
  field(:kind)
  field(:name)
  field(:number)
  field(:oneofIndex)
  field(:options, as: GoogleApi.Monitoring.V3.Model.Option, type: :list)
  field(:packed)
  field(:typeUrl)
end

defimpl Poison.Decoder, for: GoogleApi.Monitoring.V3.Model.Field do
  def decode(value, options) do
    GoogleApi.Monitoring.V3.Model.Field.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Monitoring.V3.Model.Field do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
