# Copyright 2017 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This class is auto generated by the swagger code generator program.
# https://github.com/swagger-api/swagger-codegen.git
# Do not edit the class manually.

defmodule GoogleApi.Monitoring.V3.Model.Linear do
  @moduledoc """
  Specifies a linear sequence of buckets that all have the same width (except overflow and underflow). Each bucket represents a constant absolute uncertainty on the specific value in the bucket.There are num_finite_buckets + 2 (&#x3D; N) buckets. Bucket i has the following boundaries:Upper bound (0 &lt;&#x3D; i &lt; N-1): offset + (width * i).  Lower bound (1 &lt;&#x3D; i &lt; N): offset + (width * (i - 1)).

  ## Attributes

  - numFiniteBuckets (integer()): Must be greater than 0. Defaults to: `null`.
  - offset (float()): Lower bound of the first bucket. Defaults to: `null`.
  - width (float()): Must be greater than 0. Defaults to: `null`.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :numFiniteBuckets => any(),
          :offset => any(),
          :width => any()
        }

  field(:numFiniteBuckets)
  field(:offset)
  field(:width)
end

defimpl Poison.Decoder, for: GoogleApi.Monitoring.V3.Model.Linear do
  def decode(value, options) do
    GoogleApi.Monitoring.V3.Model.Linear.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Monitoring.V3.Model.Linear do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
