# Copyright 2017 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This class is auto generated by the swagger code generator program.
# https://github.com/swagger-api/swagger-codegen.git
# Do not edit the class manually.

defmodule GoogleApi.Monitoring.V3.Model.ListTimeSeriesResponse do
  @moduledoc """
  The ListTimeSeries response.

  ## Attributes

  - executionErrors ([Status]): Query execution errors that may have caused the time series data returned to be incomplete. Defaults to: `null`.
  - nextPageToken (String.t): If there are more results than have been returned, then this field is set to a non-empty value. To see the additional results, use that value as pageToken in the next call to this method. Defaults to: `null`.
  - timeSeries ([TimeSeries]): One or more time series that match the filter included in the request. Defaults to: `null`.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :executionErrors => list(GoogleApi.Monitoring.V3.Model.Status.t()),
          :nextPageToken => any(),
          :timeSeries => list(GoogleApi.Monitoring.V3.Model.TimeSeries.t())
        }

  field(:executionErrors, as: GoogleApi.Monitoring.V3.Model.Status, type: :list)
  field(:nextPageToken)
  field(:timeSeries, as: GoogleApi.Monitoring.V3.Model.TimeSeries, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.Monitoring.V3.Model.ListTimeSeriesResponse do
  def decode(value, options) do
    GoogleApi.Monitoring.V3.Model.ListTimeSeriesResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Monitoring.V3.Model.ListTimeSeriesResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
