# Copyright 2017 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This class is auto generated by the swagger code generator program.
# https://github.com/swagger-api/swagger-codegen.git
# Do not edit the class manually.

defmodule GoogleApi.Monitoring.V3.Model.Metric do
  @moduledoc """
  A specific metric, identified by specifying values for all of the labels of a MetricDescriptor.

  ## Attributes

  - labels (%{optional(String.t) &#x3D;&gt; String.t}): The set of label values that uniquely identify this metric. All labels listed in the MetricDescriptor must be assigned values. Defaults to: `null`.
  - type (String.t): An existing metric type, see google.api.MetricDescriptor. For example, custom.googleapis.com/invoice/paid/amount. Defaults to: `null`.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :labels => map(),
          :type => any()
        }

  field(:labels, type: :map)
  field(:type)
end

defimpl Poison.Decoder, for: GoogleApi.Monitoring.V3.Model.Metric do
  def decode(value, options) do
    GoogleApi.Monitoring.V3.Model.Metric.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Monitoring.V3.Model.Metric do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
