# Copyright 2017 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This class is auto generated by the swagger code generator program.
# https://github.com/swagger-api/swagger-codegen.git
# Do not edit the class manually.

defmodule GoogleApi.Monitoring.V3.Model.MutationRecord do
  @moduledoc """
  Describes a change made to a configuration.

  ## Attributes

  - mutateTime (DateTime.t): When the change occurred. Defaults to: `null`.
  - mutatedBy (String.t): The email address of the user making the change. Defaults to: `null`.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :mutateTime => DateTime.t(),
          :mutatedBy => any()
        }

  field(:mutateTime, as: DateTime)
  field(:mutatedBy)
end

defimpl Poison.Decoder, for: GoogleApi.Monitoring.V3.Model.MutationRecord do
  def decode(value, options) do
    GoogleApi.Monitoring.V3.Model.MutationRecord.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Monitoring.V3.Model.MutationRecord do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
