# Copyright 2017 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This class is auto generated by the swagger code generator program.
# https://github.com/swagger-api/swagger-codegen.git
# Do not edit the class manually.

defmodule GoogleApi.Monitoring.V3.Model.UptimeCheckIp do
  @moduledoc """
  Contains the region, location, and list of IP addresses where checkers in the location run from.

  ## Attributes

  - ipAddress (String.t): The IP address from which the uptime check originates. This is a full IP address (not an IP address range). Most IP addresses, as of this publication, are in IPv4 format; however, one should not rely on the IP addresses being in IPv4 format indefinitely and should support interpreting this field in either IPv4 or IPv6 format. Defaults to: `null`.
  - location (String.t): A more specific location within the region that typically encodes a particular city/town/metro (and its containing state/province or country) within the broader umbrella region category. Defaults to: `null`.
  - region (String.t): A broad region category in which the IP address is located. Defaults to: `null`.
    - Enum - one of [REGION_UNSPECIFIED, USA, EUROPE, SOUTH_AMERICA, ASIA_PACIFIC]
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :ipAddress => any(),
          :location => any(),
          :region => any()
        }

  field(:ipAddress)
  field(:location)
  field(:region)
end

defimpl Poison.Decoder, for: GoogleApi.Monitoring.V3.Model.UptimeCheckIp do
  def decode(value, options) do
    GoogleApi.Monitoring.V3.Model.UptimeCheckIp.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Monitoring.V3.Model.UptimeCheckIp do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
